.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\gdi32.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\ole32.lib
includelib  \masm32\lib\oleaut32.lib
includelib  ..\lib\LoadImage.lib

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD
LoadImageFromFile PROTO :DWORD

.data
szImgFile   db 'image.jpg',0
capt        db 'Error',0
message     db 'LoadImageFromFile could not load the image',0

.data?
hBitmap     dd ?
buffer      db MAX_PATH dup(?)

.code

start:

    invoke  GetModuleHandle,NULL
    invoke  DialogBoxParam,eax,1000,NULL,ADDR DlgProc,NULL
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    LOCAL ps:PAINTSTRUCT
    LOCAL bm:BITMAP
    LOCAL hdc:HDC
    LOCAL hMemDC:HDC
    LOCAL hOldBitmap:HBITMAP
    LOCAL pFilePart:DWORD
    
    .IF uMsg==WM_INITDIALOG
	

        invoke  GetFullPathName,ADDR szImgFile,MAX_PATH,ADDR buffer,ADDR pFilePart
        invoke  LoadImageFromFile,ADDR buffer

        .IF !eax
        
            invoke  MessageBox,0,ADDR message,ADDR capt,MB_OK or MB_ICONEXCLAMATION
            invoke  SendMessage,hWnd,WM_CLOSE,0,0

        .ENDIF
        
        mov     hBitmap,eax

    .ELSEIF uMsg==WM_PAINT
	
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hdc,eax
        invoke  CreateCompatibleDC,eax
        mov     hMemDC,eax
        invoke  SelectObject,eax,hBitmap
        mov     hOldBitmap,eax
        invoke  GetObject,hBitmap,SIZEOF BITMAP,ADDR bm
        
        invoke  BitBlt,hdc,0,0,bm.bmWidth,bm.bmHeight,hMemDC,0,0,SRCCOPY
        invoke  SelectObject,hMemDC,hOldBitmap
        invoke  DeleteDC,hMemDC
        invoke  EndPaint,hWnd,ADDR ps

    .ELSEIF uMsg==WM_CLOSE

        invoke  DeleteObject,hBitmap
        invoke  EndDialog,hWnd,NULL

    .ELSE

        mov eax,FALSE
        ret
        
    .ENDIF
    
    mov     eax,TRUE
    ret

DlgProc ENDP

END start

